<template>
  <v-container>
    <v-layout row wrap class="justify-center">
      <v-flex xs12 sm8 md6 lg5 xl4>
        <v-layout row class="align-baseline">
          <p class="headline font-weight-medium">
            Browse insights found with
            <span class="font-weight-light">
              <span class="primary--text">DAVIS</span> 420
            </span>
          </p>
        </v-layout>
        <v-card
          v-for="insight in insights"
          :key="insight.id"
          class="my-3 pa-2 pl-4"
        >
          <v-layout row class="align-center">
            <v-flex grow>
              <span class="font-weight-bold">Title:</span>
              {{ insight.title || "No title" }}
              <br />
              <span class="font-weight-bold">Author:</span>
              {{ insight.author || "Anonymous" }}
              <br />
              <span class="font-weight-bold">Added:</span>
              {{ getTime(insight.timestamp) }}
            </v-flex>
            <v-flex shrink>
              <v-btn
                fab
                outline
                color="success"
                @click="goToInsight(insight.id)"
              >
                <v-icon>chevron_right</v-icon>
              </v-btn>
            </v-flex>
          </v-layout>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import { mapState } from "vuex";
import moment from "moment";

export default {
  computed: {
    ...mapState(["insights"])
  },
  methods: {
    goToInsight(id) {
      this.$router.push(`/insights/${id}`);
    },
    getTime(timestamp) {
      if (timestamp) {
        const { seconds } = timestamp;
        return moment.unix(seconds).fromNow();
      }
    }
  },
  created() {
    this.$store.dispatch("bindInsightsRef");
  }
};
</script>
